close all

cmap=[ 
    0    0.4470    0.7410
    0.8500    0.3250    0.0980
    0.9290    0.6940    0.1250
    0.4940    0.1840    0.5560
    0.4660    0.6740    0.1880
    0.3010    0.7450    0.9330
    0.6350    0.0780    0.1840];

FFT=1;

wvlim=101;

%%%%%%%%Averaging Data
%Series 1
MeanBuffer=mean(Buffer(1:wvlim,2:end),2);
MeanHHDub0k25=mean(HHDub0k25(1:wvlim,2:end),2);
MeanHHDub0k5=mean(HHDub0k5(1:wvlim,2:end),2);
MeanHHDub1k0=mean(HHDub1k0(1:wvlim,2:end),2);
MeanHHDub2k0=mean(HHDub2k0(1:wvlim,2:end),2);
MeanHHDubPP2k0=mean(HHDubPP2k0(1:wvlim,2:end),2);
MeanPolymerPhase=mean(PolymerPhase(1:wvlim,2:end)*0.99+MeanBuffer(1:wvlim,:)*0.01,2);
AllBuffer=[MeanBuffer,MeanHHDub0k25,MeanHHDub0k5,MeanHHDub1k0,MeanHHDub2k0];
AllPolymerPhase=[MeanPolymerPhase,MeanHHDubPP2k0];
wvAll=HHDubPP2k0(1:wvlim,1);

%Series 2
MeanBuffer_2=mean(Buffer_2(1:wvlim,2:end),2);
MeanHHDubPP2k0_2=mean(HHDubPP2k0_2(1:wvlim,2:end),2);
MeanPolymerPhase_2=mean(PolymerPhase_2(1:wvlim,2:end)*0.96+MeanBuffer_2(1:wvlim,:)*0.04,2);
AllBuffer_2=[MeanBuffer_2];
AllPolymerPhase_2=[MeanPolymerPhase_2,MeanHHDubPP2k0_2];



%%%%%Background substraction
for i=1:5
    AllBuffer(:,i)=AllBuffer(:,i)-AllBuffer(1,i);
    if i==1
        AllBuffer_2(:,i)=AllBuffer_2(:,i)-AllBuffer_2(1,i);
    end
    AllBufferBG(:,i)=AllBuffer(:,i)-AllBuffer(:,1);
    if i==1
        AllBuffer_2(:,i)=AllBuffer_2(:,i)-AllBuffer_2(1,i);
    end
end
for i=1:2
    AllPolymerPhase(:,i)=AllPolymerPhase(:,i)-AllPolymerPhase(1,i);
    AllPolymerPhase_2(:,i)=AllPolymerPhase_2(:,i)-AllPolymerPhase_2(1,i);
end


%%%%%Correction for remaining offset of Buffer and Sample (306 to 310 nm) 
for i=1:2
    [Offset]=OffsetFit(MeanBuffer,AllPolymerPhase(1:101,i));
    AllPPBG(:,i)=AllPolymerPhase(:,i)-Offset-MeanBuffer;
    [Offset]=OffsetFit(MeanBuffer_2,AllPolymerPhase_2(:,i));
    AllPPBG_2(:,i)=AllPolymerPhase_2(:,i)-Offset-MeanBuffer_2;
end


%smoothe if FFT=1
if FFT==1
    for j=1:5
        scale=AllBufferBG(:,j)';
        FFTCD
        plot(smoothedscale)
        smoothedscale=smoothedscale';
        AllBufferFFT(:,j)=smoothedscale;
        if j==1:1
            scale=AllBuffer_2(:,j)';
            FFTCD
            plot(smoothedscale)
            smoothedscale=smoothedscale';
            AllBufferFFT_2(:,j)=smoothedscale;
        end

    end
    for j=1:2
        scale=AllPPBG(:,j)';
        FFTCD
        plot(smoothedscale)
        smoothedscale=smoothedscale';
        AllPolymerPhaseFFT(:,j)=smoothedscale;
        scale=AllPPBG_2(:,j)';
        FFTCD
        plot(smoothedscale)
        smoothedscale=smoothedscale';
        AllPolymerPhaseFFT_2(:,j)=smoothedscale;
    end
else
    AllBufferFFT=AllBufferBG;
    AllBufferFFT_2=AllBuffer_2;
    AllPolymerPhaseFFT=AllPPBG;
    AllPolymerPhaseFFT_2=AllPPBG_2;
end
    


%%Plotting Data
wvlim=88;  
figure(1)
Concentrations=[0 0.25 0.5 1 2].*1e-6;
Pathlength=0.1;
    %%1 muM HH-mut in Buffer (yellow)
    Faktor=1/(Concentrations(4)*Pathlength*10);  %      /10 mol to dmol
    for i=1:wvlim
        STDHHB1k0(i)=std(HHDub1k0(i,2:end));
        HHB1k0Low(i)=AllBufferFFT(i,4)-STDHHB1k0(i);
        HHB1k0High(i)=AllBufferFFT(i,4)+STDHHB1k0(i);
    end
    inBetween2 = [HHB1k0Low, fliplr(HHB1k0High)];
    wvuse=[wvAll(1:wvlim)',fliplr(wvAll(1:wvlim)')];
        fill(wvuse, inBetween2*Faktor,cmap(3,:),...
            'facecolor',cmap(3,:), ...
            'edgecolor','none', ...
            'facealpha', 0.3);
        hold on
        h3=plot(wvAll(1:wvlim),AllBufferFFT(1:wvlim,4)*Faktor,'color',cmap(3,:));
 
    %%2 muM HH-mut in Buffer (red)
    Faktor=1/(Concentrations(5)*Pathlength*10);  %      /10 mol to dmol
    for i=1:wvlim
        STDHHB2k0(i)=std(HHDub2k0(i,2:end));
        HHB2k0Low(i)=AllBufferFFT(i,5)-STDHHB2k0(i);
        HHB2k0High(i)=AllBufferFFT(i,5)+STDHHB2k0(i);
    end
    inBetween2 = [HHB2k0Low, fliplr(HHB2k0High)];
    wvuse=[wvAll(1:wvlim)',fliplr(wvAll(1:wvlim)')];
        fill(wvuse, inBetween2*Faktor,cmap(2,:),...
            'facecolor',cmap(2,:), ...
            'edgecolor','none', ...
            'facealpha', 0.3);
        hold on
        h4=plot(wvAll(1:wvlim),AllBufferFFT(1:wvlim,5)*Faktor,'color',cmap(2,:));
    
    %%2 muM HH-mut in bulk coacervate phase (blue)
    Faktor=1/(Concentrations(5)*Pathlength*10);  %      /10 mol to dmol
    for i=1:wvlim
        STDHHPP_2(i)=std([HHDubPP2k0_2(i,2:end) HHDubPP2k0(i,2:end)]);
        HHPPLow_2(i)=mean([AllPolymerPhaseFFT_2(i,2)-AllPolymerPhaseFFT_2(i,1) AllPolymerPhaseFFT(i,2)-AllPolymerPhaseFFT(i,1)]) -STDHHPP_2(i);
        HHPPHigh_2(i)=mean([AllPolymerPhaseFFT_2(i,2)-AllPolymerPhaseFFT_2(i,1) AllPolymerPhaseFFT(i,2)-AllPolymerPhaseFFT(i,1)]) +STDHHPP_2(i);
    end
    inBetween1 = [HHPPLow_2, fliplr(HHPPHigh_2)];
    wvuse=[wvAll(1:wvlim)',fliplr(wvAll(1:wvlim)')];
        fill(wvuse, inBetween1*Faktor,cmap(1,:),...
            'facecolor',cmap(1,:), ...
            'edgecolor','none', ...
            'facealpha', 0.3);
        hold on
        h1=plot(wvAll(1:wvlim),mean([(AllPolymerPhaseFFT_2(1:wvlim,2)-AllPolymerPhaseFFT_2(1:wvlim,1)) (AllPolymerPhaseFFT(1:wvlim,2)-AllPolymerPhaseFFT(1:wvlim,1)) ],2)*Faktor,'color',cmap(1,:));
        axis([245 310 -4e5 0.7e6])
    
    %%plotting arrows    
    p1=[270 6.9e5 0];
    p2=[265 6.167e5 0];
    arrow(p1,p2,24,'Ends',str2mat('stop'),'Width',0.6,'Length',8,'Color',cmap(2,:));%[0.3 0.3 0.3])
	t4=text(p1(1),p1(2),'265 nm','Color',cmap(2,:));
	set(t4,'HorizontalAlignment','left');

    p1=[270 1.35e5 0];
    p2=[268 3.45e5 0];
    arrow(p1,p2,24,'Ends',str2mat('stop'),'Width',0.6,'Length',8,'Color',cmap(1,:));%[0.3 0.3 0.3])
	t4=text(p1(1),p1(2),'268 nm','Color',cmap(1,:));
	set(t4,'HorizontalAlignment','left');
    
    %%plot zero line
    plot([0 350],[0 0],'color',[0.3 0.3 0.3])
    
    xlabel({'Wavelength (nm)'})
    ylabel({'[\theta]'; '(deg  cm^2  dmol^{-1})'})
    box off



    
clear h1 h2 h3 h4 h5 h6 h7 FFT Concentrations Faktor HHB0k25Low HHB0k25High HHB0k5Low HHB0k5High HHB1k0Low HHB1k0High HHB2k0Low HHB2k0High  HHPPHigh HHPPHigh_2 
clear HHPPLow HHPPLow_2 HHPPRAWHigh HHPPRAWLow i j inBetween1 inBetween2 muopt muopt1 Offset p1 p2 Pathlength PPHigh PPLow STDHHB0k25 STDHHB0k5 STDHHB1k0 STDHHB2k0
clear STDHHPP STDHHPP_2 STDHHPPRAW STDPP
clear MeanBuffer MeanBuffer_2 MeanHHDub0k25 MeanHHDub0k5 MeanHHDub1k0 MeanHHDub2k0 MeanHHDubPP2k0 MeanHHDubPP2k0_2 MeanPolymerPhase MeanPolymerPhase_2
clear wvlim wvlim2 wvuse t4 ans AllBuffer AllBuffer_2 AllPolymerPhase AllPolymerPhase_2  cmap
clear AllBufferFFT smoothedscale scale AllBufferBG AllBufferBG_2 AllPPBG_2 AllPPBG AllBufferFFT_2 AllBufferFFT AllPolymerPhaseFFT_2 AllPolymerPhaseFFT
